#include "extern.h"
#include "hwCtrl.h"
#include "PINdef.h"

#pragma section const DID_TBL

__far const unsigned char HD_VERSION[]={
	'H' ,		//AC_HD_VERSION_00
	'W' ,		//AC_HD_VERSION_01
	'0' ,		//AC_HD_VERSION_02
	'1' ,		//AC_HD_VERSION_03
	'0' ,		//AC_HD_VERSION_04
	'0' ,		//AC_HD_VERSION_05
	' ' ,		//AC_HD_VERSION_06
	' ' ,		//AC_HD_VERSION_07
	' ' ,		//AC_HD_VERSION_08
	' ' ,		//AC_HD_VERSION_09
	' ' ,		//AC_HD_VERSION_10
	' ' ,		//AC_HD_VERSION_11
	' ' ,		//AC_HD_VERSION_12
	' ' ,		//AC_HD_VERSION_13
	' ' ,		//AC_HD_VERSION_14
	' ' ,		//AC_HD_VERSION_15
};

__far const unsigned char SW_VERSION[]={
	'0' ,		//AC_SW_VERSION_00
	'1' ,		//AC_SW_VERSION_01
	'.' ,		//AC_SW_VERSION_02
	'0' ,		//AC_SW_VERSION_03
	'1' ,		//AC_SW_VERSION_04
	'.' ,		//AC_SW_VERSION_05
	'0' ,		//AC_SW_VERSION_06
	'1' ,		//AC_SW_VERSION_07
	' ' ,		//AC_SW_VERSION_08
	' ' ,		//AC_SW_VERSION_09
	' ' ,		//AC_SW_VERSION_10
	' ' ,		//AC_SW_VERSION_11
	' ' ,		//AC_SW_VERSION_12
};

__far const unsigned char SUP_ECU_SW_VERSION[]={
	'0' ,		//
	'2' ,		//
	'0' ,		//
	'1' ,		//
	' ' ,		//
	' ' ,		//
	' ' ,		//
	' ' ,		//
	' ' ,		//
	' ' ,		//
	' ' ,		//
	' ' ,		//
	' ' ,		//
	' ' ,		//
	' ' ,		//
	' ' ,		//
};


#pragma section


IO_parameter_t io_parameter[8];

const unsigned char DID_0xF110_VehicleNetworkConfiguration[8]={0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20};
const unsigned char DID_0xF190_vehicleIdentificationNumber[17]={0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20};
const unsigned char DID_0xF197_SystemNameOrEngineType[8]={0x44,0x41,0x4D,0x49,0x4e,0x47,0x41,0x43};
const unsigned char DID_0xF198_RepairShopCodeOrTesterSerialNumber[16]={0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20};
const unsigned char DID_0xF199_ProgrammingOrConfigurationDate[4]={0x20,0x00,0x01,0x01};
const unsigned char DID_0xF19D_ECUInstallationDateDataIdentifier[4]={0x20,0x00,0x01,0x01};
const unsigned char DID_0xF112_VehicleName[8]={0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20};
 can_frame_t TxCanMessageT;
//const unsigned char DID_0xF15A[]={};
/****************************************************************************************/
/* 		 ch :  								*/
/*	     	0: ѹ¶                  					    	*/
/*          	1: ¶                                   			    	*/
/*          	2: ¶                                   			    	*/
/* 	    	ֵ                                               			*/
/*          	Ӧĵѹ*10صĵѹֵ0.1Vģ        				*/
/*                                            						*/

unsigned char GetVoltage(unsigned char ch)
{

	/* ķʽأҪ㣬 return Voltage[ch]; */
//	switch(ch)
//	{
//		case EVA_SENSOR:
//		return uiDuctAdVal;
//		break;
//		case OUTSIDE_SENSOR:
//		return uiAmbAdVal;
//		break;
//		case INSIDE_SENSOR:
//		return uiIncarAdVal;
//		break;
//		default:
//			return 0;
//		break;
//	}
}

/************************************************************************************/
/*  motor :  																*/
/*          1: ʻԱ¶ȵڵ                                         		*/
/*          2: ģʽ                                        		 		*/
/*          3: ѭŵڵ                                             		*/
/*                                                                                  */
/* ֵ                                                                         */
/*          0:  1ת                             					*/
/*                                                                                  */
unsigned char GetMotorLockStatus(unsigned char motor)
{
//	switch(motor)
//	{
//		case 1:
//			return temprunErr;
//		break;
//		case 2:
//			return moderunErr;
//		break;
//		case 3:
//			return 0;
//		break;
//		default:
//			return 0;
//		break;
//	}
}

/************************************************************************************/
/*  p :  																	*/
/* 				0: TEMP 	ʻԱ¶ȷλ 	     							*/
/* 				1: REC		ѭģʽ		                            		*/
/* 				2: FAN		ķλ		                            			*/
/* 				3: MODE		ģʽλ		            */
/* 				4: DEFROST	˪	                            				*/
/* 				5: REARDEF	˪	                            				*/
/* 				6: AC 		A/C䰴	                            			*/
/* 				7: K30		ECU Supplier voltage  		                            */
/*                                                                                  */
/* ֵ                                                                         */
/*          0: Ӧdata,222F                             				*/
/************************************************************************************/
unsigned char GetIoParameter(unsigned char p)
{
	switch(p)
	{
		case 0:

		break;
		case 1:

		break;
		case 2:

		break;
		case 3:

		break;
		case 4:

		break;
		case 5:

		break;
		case 6:

		break;
		case 7:

		break;
		default:
			return 0;
		break;
	}
	return (io_parameter[p].data);
}

/************************************************************************************/
/*                                   ѯ                                  */
/* p :  																	*/
/* 				0: TEMP 	ʻԱ¶ȷλ 	     							*/
/* 				1: REC		ѭģʽ		                            		*/
/* 				2: FAN		ķλ		                            			*/
/* 				3: MODE		ģʽλ		                            		*/
/* 				4: DEFROST	Ч	                            					*/
/* 				5: REARDEF	˪	                            				*/
/* 				6: AC 		Ч	                            					*/
/* 				7: K30		Ч  		                            				*/
/* ֵ                                                                         */
/*                                        											*/
/************************************************************************************/
void WriteIoParameter(unsigned char p,unsigned char data)
{
	io_parameter[p].write = 1;		//ֵΪ1ҪԶӦõĲдdataAPPд㡣
	io_parameter[p].data = data;
}

/************************************************************************************/
/*  p :  																	*/
/*                                                   								*/
/*                                                                                  */
/* ֵ                                                                         */
/*          0: IGNԴ     1IGN > 16V  IGN < 9V                         	*/
/*                                                                                  */
/************************************************************************************/
unsigned char GetIgnVoltStatus(void)
{
//	if(*Power_Protect.mark == 1)
//	{
//		return 0;
//	}
//	else
//	{
//		return 1;
//	}
	return 0;
}


unsigned char TransmitCAN_Message(unsigned int ID,unsigned char Dlc,unsigned char *Data)
{
	
	Can_RtnType re_flag;
	TxCanMessageT.IDL=ID;
	TxCanMessageT.DLC=Dlc;
	TxCanMessageT.IDE = 0;     	 /* IDE  0:Standard 1:Extend           */
	TxCanMessageT.RTR = 0;     	 /* RTR  0:Data 1:Remote               */
	TxCanMessageT.THDSE = 0;   	 /* Transmit History Data Store Enable */
	TxCanMessageT.IDH = 0;       /* ID Data (high)                     */
	TxCanMessageT.DLC = 8;     	 /* DLC Data                           */
	TxCanMessageT.LBL = 0;     	 /* Label Data                         */
	TxCanMessageT.TS = 0;      	 /* Timestamp Data                     */
	Copy_Array_to_Array(TxCanMessageT.DB,Data,Dlc);
	re_flag=R_CAN_TrmByTRFIFO0_CH0(&TxCanMessageT);
	if(re_flag == CAN_RTN_OK)
	{
		return 0;
	}
	else
	{
		return 1;
	}
}

unsigned char DF_Write(unsigned char* write_buf,unsigned char data_num,unsigned char len)
{
	unsigned char DID_Buf[0x50],i;
	i=0;
	switch(data_num)
	{
		case 1:
			ReadFlashData(DID_Buf,0x000F1000+0x400,0x50);
			for(i=0;i<len;i++)
			{
				DID_Buf[i+0]=*write_buf;
				write_buf++;
			}
			if(WriteDataflash(DID_Buf,0x000F1000+0x400,0x50) == 0x11)
			{
				return 0;
			}
		break;
		case 2:
			ReadFlashData(DID_Buf,0x000F1000+0x400,0x50);
			for(i=0;i<len;i++)
			{
				DID_Buf[i+0x40]=*write_buf;
				write_buf++;
			}
			if(WriteDataflash(DID_Buf,0x000F1000+0x400,0x50) == 0x11)
			{
				return 0;
			}
		break;
		case 3:
			ReadFlashData(DID_Buf,0x000F1000+0x400,0x50);
			for(i=0;i<len;i++)
			{
				DID_Buf[i+0x30]=*write_buf;
				write_buf++;
			}
			if(WriteDataflash(DID_Buf,0x000F1000+0x400,0x50) == 0x11)
			{
				return 0;
			}
		break;
		case 4:
			ReadFlashData(DID_Buf,0x000F1000+0x400,0x50);
			for(i=0;i<len;i++)
			{
				DID_Buf[i+0x38]=*write_buf;
				write_buf++;
			}
			if(WriteDataflash(DID_Buf,0x000F1000+0x400,0x50) == 0x11)
			{
				return 0;
			}
		break;
		
		default:
		break;

	}
	return 0;
}

unsigned char DF_Read(unsigned char* read_buf,unsigned char data_num,unsigned char len)
{
	switch(data_num)
	{
		case 1:
			ReadFlashData(read_buf,0x000F1000+0x400,len);
			return 0;
		break;
		case 2:
			ReadFlashData(read_buf,0x000F1000+0x420,len);
			return 0;
		break;
		case 3:
			ReadFlashData(read_buf,0x000F1000+0x430,len);
			return 0;
		break;
		case 4:
			ReadFlashData(read_buf,0x000F1000+0x438,len);
			return 0;
		break;
		
		default:
		break;
	}
	return 0;
}

uint32 GetTimerCnt(void)
{
	return Can_1ms_count_alive;
}
/************************************************************************************
// ȡdata Flashݴȡ														//
//  code :  																//
//			0 : ȡAPPر־											//
//			1 : ȡ2E0xF110                                            //
//			2 : ȡ2E0xF190                                            //
//			3 : ȡ2E0xF197                                            //
//			4 : ȡ2E0xF198                                            //
//			5 : ȡ2E0xF199                                            //
//			6 : ȡ2E0xF19D                                    		//
//                      7 : ȡ2E0xF112                                                            //
//                      8 : ȡ190xF00616
//                      9 : ȡ190xF00617
//                      10: ȡ190x918112
//                      11: ȡ190x918114
//                      12: ȡ190x918171
//                      13: ȡ190x918312
//                      14: ȡ190x918314
//                      15: ȡ190x918371
//                      16: ȡ190x918412
//                      17: ȡ190x918414
//                      18: ȡ190x918471
//                      19: ȡ190x918611
//                      20: ȡ190x918614
//                      21: ȡ190xC07300
// ֵ                                                                         //
//          2E                          								//
//                                                                                  //
************************************************************************************/

const unsigned char DF_INDEX_TAB[]={
	0U , 		//APP REProgrammer Request
	1U , 		//BLOCK_0xF110,
	2U , 		//BLOCK_0xF190,
	3U , 		//BLOCK_0xF197,
	4U , 		//BLOCK_0xF198,
	5U , 		//BLOCK_0xF199,
	6U , 		//BLOCK_0xF19D,
	7U ,        //BLOCK_0xF112,
	8U ,            //190xF00616
	9U ,            //190xF00617
	10U ,           //190x918112
	11U ,           //190x918114
	12U ,           //190x918171
	13U ,           //190x918312
	14U ,           //190x918314
	15U ,           //190x918371
	16U ,           //190x918412
	17U ,           //190x918414
	18U ,           //190x918471
	19U ,           //190x918611
	20U ,           //190x918614
	21U             //190xC07300
};


unsigned char GetIndexNumber(unsigned char code)
{
	return(DF_INDEX_TAB[code]);
}

/************************************************************************************
// ȡACӲ汾																	//
//  hdv :  																	//
//			ָȡݴĻĵַ											//
//                                                                                  //
// ֵ                                                                         //
//                                                  								//
//                                                                                  //
************************************************************************************/



void GetHardwareVersion(unsigned char* hdv)
{
	unsigned char cnt;

	for(cnt=0;cnt<16;cnt++){
		hdv[cnt]  = HD_VERSION[cnt];
	}

}

/************************************************************************************
// ȡAC汾																	//
//  swv :  																	//
//			ָȡݴĻĵַ											//
//                                                                                  //
// ֵ                                                                         //
//                                                  								//
//                                                                                  //
************************************************************************************/

void GetSoftwareVersion(unsigned char* swv)
{
	unsigned char cnt;

	for(cnt=0;cnt<13;cnt++){
		swv[cnt]  = SW_VERSION[cnt];
	}
}

/************************************************************************************
// ȡACӦ汾																	//
//  swv :  																	//
//			ָȡݴĻĵַ											//
//                                                                                  //
// ֵ                                                                         //
//                                                  								//
//                                                                                  //
************************************************************************************/

void GetSupplierSoftwareVersion(unsigned char* swv)
{
	unsigned char cnt;

	for(cnt=0;cnt<16;cnt++){
		swv[cnt]  = SUP_ECU_SW_VERSION[cnt];
	}

}



/************************************************************************************
// ȡAC																	//
//  *date :  																//
//			data[0] = YEAR															//
//			data[1] = MONTH															//
//			data[0] = DAY															//
//                                                                                  //
// ֵ                                                                         //
//                                                  								//
//                                                                                  //
************************************************************************************/

const unsigned char MANUFACTURING_DATE[]={
	0x18,		//Year
	0x06,		//Month
	0x15,		//Day
};

void GetManufacturingDate(unsigned char* date)
{
	date[0] = MANUFACTURING_DATE[0];
	date[1] = MANUFACTURING_DATE[1];
	date[2] = MANUFACTURING_DATE[2];
}

/******************************/
//ȡcan߳״̬
//ֵ
/******************************/
unsigned char GetCanBusOffErr(void)
{
//	if(BusOff_flag==0)
//		return 0;
//	else
//		return 1;
}
/******************************/
//ȡBCMڵ㶪ʧ״̬
//ֵ
/******************************/

unsigned char GetBcmCommFault(void)
{
//	if(uiBcmCommFaultCnt < 500)
//	{
//		return 0;
//	}
//	else
//	{
//		BCM_Recover=0;
//		BCM=0;
//		return 1;
//	}
}
/******************************/
//ȡACPڵ㶪ʧ״̬
//ֵ
/******************************/
unsigned char GetAcpCommFault(void)
{
//	if(uiAcpCommFaultCnt < 500)
//	{
//		return 0;
//	}
//	else
//	{
//		ACP_Recover=0;
//		ACP=0;
//		return 1;
//	}
}

/******************************/
//ȡʷɹ̴
//
//
//ֵʷɹ̴
/******************************/
unsigned char GetProgrammingCounter(void)
{
	return 0;
}
/******************************/
//ȡʷ̴
//
//
//ֵʷ̴
/******************************/
unsigned char GetProgrammingAttempCounter(void)
{
	return 0;
}

/******************************/
//DTC
//ĿǰBusOff
//
//ֵ0
/******************************/
unsigned char Clear_DTC_Data(void)
{
	//Clear_DTC_Data_Command=1;
	return 0;
}



//S51EV




void getInputState(unsigned char* data)
{
 

}

void getOutputState(unsigned char* data)
{

}
extern uint16_t SupplyVoltage;
void getSupplyVoltage(unsigned char* data)
{
    data[0] = SupplyVoltage;
}
