#ifndef __PINDEF_H__
#define __PINDEF_H__

#include "iodefine.h"

#define CAN_STB		    P1_bit.no2   //


#define KEY_P16         P1_bit.no6   //
#define KEY_P17         P1_bit.no7   //
#define KEY_P30         P3_bit.no0   //
#define KEY_P34         P3_bit.no4   //
#define KEY_P41         P4_bit.no1   //
#define KEY_P60         P6_bit.no0   //
#define KEY_P61         P6_bit.no1   //
#define KEY_P62         P6_bit.no2   //
#define KEY_P63         P6_bit.no3   //
#define KEY_P85         P8_bit.no5   //
#define KEY_P84         P8_bit.no4   //
#define KEY_P83         P8_bit.no3   //
#define KEY_P82         P8_bit.no2   //
#define KEY_P81         P8_bit.no1   //
#define KEY_P80         P8_bit.no0   //
#define KEY_P120        P12_bit.no0  //
#define KEY_P125        P12_bit.no5  //
#define KEY_P137        P13_bit.no7

#define KEYID_P16   0
#define KEYID_P17   1
#define KEYID_P30   2
#define KEYID_P34   3
#define KEYID_P41   4
#define KEYID_P60   5
#define KEYID_P61   6
#define KEYID_P62   7   
#define KEYID_P63   8
#define KEYID_P85   9
#define KEYID_P84   10
#define KEYID_P83   11
#define KEYID_P82   12
#define KEYID_P81   13
#define KEYID_P80   14
#define KEYID_P120  15
#define KEYID_P125  16
#define KEYID_P137  17
#define KEY_NUM     18

#define ADCH_IGN    0


#define LEFT_BOARD  1
#define RIGHT_BOARD 2
#define NOW_BOARD LEFT_BOARD


#endif

